> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# Create or update a grant

POST https://api.sigmacomputing.com/v2/grants
Content-Type: application/json

Create a grant or update an existing grant on a document, folder, or workspace to a user or a team by ID.

  ### Usage notes
  - This endpoint can only be used to escalate the level of access that a user has to a document. To remove or reduce a user's access to a specific document, call [/v2/grants/{grantId}](https://help.sigmacomputing.com/reference/delete-grant) to delete the existing grant and re-grant the desired level of access.
  - Retrieve the **memberId** by calling the [/v2/members](https://help.sigmacomputing.com/reference/list-members) endpoint.
  - Retrieve the **teamId** by calling the [/v2/teams](https://help.sigmacomputing.com/reference/list-teams) endpoint.
  - Retrieve the **inodeId** by calling the [/v2/files](https://help.sigmacomputing.com/reference/list-files) endpoint and using the `id` included in the response.
  - Retrieve the **inodeId** for a data model by calling the [/v2/dataModels](https://help.sigmacomputing.com/reference/list-data-models) endpoint and using the `dataModelId` included in the response.
  - Optionally specify a **tagId** to associate the permission with a specific version tag of a workbook, dataset (deprecated), or database table. Retrieve the **tagId** by calling the [/v2/tags](https://help.sigmacomputing.com/reference/list-version-tag) endpoint and using the `versionTagId` included in the response.
    

Reference: https://help.sigmacomputing.com/reference/create-grant

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: sigma-rest-api
  version: 1.0.0
paths:
  /v2/grants:
    post:
      operationId: createGrant
      summary: Create or update a grant
      description: >-
        Create a grant or update an existing grant on a document, folder, or
        workspace to a user or a team by ID.

          ### Usage notes
          - This endpoint can only be used to escalate the level of access that a user has to a document. To remove or reduce a user's access to a specific document, call [/v2/grants/{grantId}](https://help.sigmacomputing.com/reference/delete-grant) to delete the existing grant and re-grant the desired level of access.
          - Retrieve the **memberId** by calling the [/v2/members](https://help.sigmacomputing.com/reference/list-members) endpoint.
          - Retrieve the **teamId** by calling the [/v2/teams](https://help.sigmacomputing.com/reference/list-teams) endpoint.
          - Retrieve the **inodeId** by calling the [/v2/files](https://help.sigmacomputing.com/reference/list-files) endpoint and using the `id` included in the response.
          - Retrieve the **inodeId** for a data model by calling the [/v2/dataModels](https://help.sigmacomputing.com/reference/list-data-models) endpoint and using the `dataModelId` included in the response.
          - Optionally specify a **tagId** to associate the permission with a specific version tag of a workbook, dataset (deprecated), or database table. Retrieve the **tagId** by calling the [/v2/tags](https://help.sigmacomputing.com/reference/list-version-tag) endpoint and using the `versionTagId` included in the response.
            
      tags:
        - Grants
      parameters:
        - name: Authorization
          in: header
          description: OAuth authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: The response body.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/grants_createGrant_Response_200'
      requestBody:
        description: The request body.
        content:
          application/json:
            schema:
              type: object
              properties:
                grantee:
                  $ref: >-
                    #/components/schemas/V2GrantsPostRequestBodyContentApplicationJsonSchemaGrantee
                permission:
                  $ref: >-
                    #/components/schemas/V2GrantsPostRequestBodyContentApplicationJsonSchemaPermission
                inodeId:
                  type: string
                tagId:
                  type: string
              required:
                - grantee
                - permission
                - inodeId
servers:
  - url: https://api.sigmacomputing.com
    description: Server for GCP (US) hosted organizations
  - url: https://api.sa.gcp.sigmacomputing.com
    description: Server for GCP (KSA) hosted organizations
  - url: https://aws-api.sigmacomputing.com
    description: Server for AWS US (West) hosted organizations
  - url: https://api.us-a.aws.sigmacomputing.com
    description: Server for AWS US (East) hosted organizations
  - url: https://api.ca.aws.sigmacomputing.com
    description: Server for AWS Canada hosted organizations
  - url: https://api.eu.aws.sigmacomputing.com
    description: Server for AWS Europe hosted organizations
  - url: https://api.au.aws.sigmacomputing.com
    description: Server for AWS Australia and APAC hosted organizations
  - url: https://api.uk.aws.sigmacomputing.com
    description: Server for AWS UK hosted organizations
  - url: https://api.us.azure.sigmacomputing.com
    description: Server for Azure US hosted organizations
  - url: https://api.eu.azure.sigmacomputing.com
    description: Server for Azure Europe hosted organizations
  - url: https://api.ca.azure.sigmacomputing.com
    description: Server for Azure Canada hosted organizations
  - url: https://api.uk.azure.sigmacomputing.com
    description: Server for Azure United Kingdom hosted organizations
  - url: https://api.au.azure.sigmacomputing.com
    description: Server for Azure Australia hosted organizations
components:
  schemas:
    V2GrantsPostRequestBodyContentApplicationJsonSchemaGrantee0:
      type: object
      properties:
        memberId:
          type: string
      required:
        - memberId
      description: User or member ID
      title: V2GrantsPostRequestBodyContentApplicationJsonSchemaGrantee0
    V2GrantsPostRequestBodyContentApplicationJsonSchemaGrantee1:
      type: object
      properties:
        teamId:
          type: string
      required:
        - teamId
      description: Team ID
      title: V2GrantsPostRequestBodyContentApplicationJsonSchemaGrantee1
    V2GrantsPostRequestBodyContentApplicationJsonSchemaGrantee:
      oneOf:
        - $ref: >-
            #/components/schemas/V2GrantsPostRequestBodyContentApplicationJsonSchemaGrantee0
        - $ref: >-
            #/components/schemas/V2GrantsPostRequestBodyContentApplicationJsonSchemaGrantee1
      title: V2GrantsPostRequestBodyContentApplicationJsonSchemaGrantee
    V2GrantsPostRequestBodyContentApplicationJsonSchemaPermission0:
      type: string
      enum:
        - admin
        - annotate
        - update
        - usage
        - writeback
      description: 'Valid inode types: table, connection database, and connection schema.'
      title: V2GrantsPostRequestBodyContentApplicationJsonSchemaPermission0
    V2GrantsPostRequestBodyContentApplicationJsonSchemaPermission1:
      type: string
      enum:
        - create
        - annotate
        - organize
        - explore
        - view
        - edit
        - apply
      description: >-
        Valid inode types: folder, workspace, workbook, dataset, and data model.
        Can Contribute permissions are listed as **organize** and Can Manage
        permissions are listed as **edit**.
      title: V2GrantsPostRequestBodyContentApplicationJsonSchemaPermission1
    V2GrantsPostRequestBodyContentApplicationJsonSchemaPermission2:
      type: string
      enum:
        - view
        - edit
        - apply
      description: 'Valid inode types: version tag.'
      title: V2GrantsPostRequestBodyContentApplicationJsonSchemaPermission2
    V2GrantsPostRequestBodyContentApplicationJsonSchemaPermission:
      oneOf:
        - $ref: >-
            #/components/schemas/V2GrantsPostRequestBodyContentApplicationJsonSchemaPermission0
        - $ref: >-
            #/components/schemas/V2GrantsPostRequestBodyContentApplicationJsonSchemaPermission1
        - $ref: >-
            #/components/schemas/V2GrantsPostRequestBodyContentApplicationJsonSchemaPermission2
      title: V2GrantsPostRequestBodyContentApplicationJsonSchemaPermission
    V2GrantsPostResponsesContentApplicationJsonSchemaPermission0:
      type: string
      enum:
        - admin
        - annotate
        - update
        - usage
        - writeback
      description: 'Valid inode types: table, connection database, and connection schema.'
      title: V2GrantsPostResponsesContentApplicationJsonSchemaPermission0
    V2GrantsPostResponsesContentApplicationJsonSchemaPermission1:
      type: string
      enum:
        - create
        - annotate
        - organize
        - explore
        - view
        - edit
        - apply
      description: >-
        Valid inode types: folder, workspace, workbook, dataset, and data model.
        Can Contribute permissions are listed as **organize** and Can Manage
        permissions are listed as **edit**.
      title: V2GrantsPostResponsesContentApplicationJsonSchemaPermission1
    V2GrantsPostResponsesContentApplicationJsonSchemaPermission2:
      type: string
      enum:
        - view
        - edit
        - apply
      description: 'Valid inode types: version tag.'
      title: V2GrantsPostResponsesContentApplicationJsonSchemaPermission2
    V2GrantsPostResponsesContentApplicationJsonSchemaPermission:
      oneOf:
        - $ref: >-
            #/components/schemas/V2GrantsPostResponsesContentApplicationJsonSchemaPermission0
        - $ref: >-
            #/components/schemas/V2GrantsPostResponsesContentApplicationJsonSchemaPermission1
        - $ref: >-
            #/components/schemas/V2GrantsPostResponsesContentApplicationJsonSchemaPermission2
      description: The permission granted to the member
      title: V2GrantsPostResponsesContentApplicationJsonSchemaPermission
    V2GrantsPostResponsesContentApplicationJsonSchemaInodeType:
      type: string
      enum:
        - folder
        - customFunction
        - symlink
        - versionTag
        - worksheet
        - block
        - dashboard
        - report
        - table
        - semanticView
        - metricView
        - scope
        - sql
        - workbook
        - template
        - dataset
        - datafile
        - storedProcedure
        - apiConnector
        - apiConnectorAuth
        - mcpConnector
        - warehouseAgent
        - agentSkill
        - tlsProfile
      title: V2GrantsPostResponsesContentApplicationJsonSchemaInodeType
    grants_createGrant_Response_200:
      type: object
      properties:
        grantId:
          type: string
          description: The unique identifier of the grant
        inodeId:
          type: string
          description: The unique identifier of the inode
        organizationId:
          type: string
          description: The unique identifier of the organization
        memberId:
          type:
            - string
            - 'null'
          description: The unique identifier of the member
        teamId:
          type:
            - string
            - 'null'
          description: The unique identifier of the team
        permission:
          $ref: >-
            #/components/schemas/V2GrantsPostResponsesContentApplicationJsonSchemaPermission
          description: The permission granted to the member
        createdBy:
          type: string
          description: The identifier of the user who created this grant
        updatedBy:
          type: string
          description: The identifier of the user or process that last updated this grant
        createdAt:
          type: string
          format: date-time
          description: When the grant was created
        updatedAt:
          type: string
          format: date-time
          description: When the grant was last updated
        inodeType:
          $ref: >-
            #/components/schemas/V2GrantsPostResponsesContentApplicationJsonSchemaInodeType
      required:
        - grantId
        - inodeId
        - organizationId
        - memberId
        - teamId
        - permission
        - createdBy
        - updatedBy
        - createdAt
        - updatedAt
        - inodeType
      title: grants_createGrant_Response_200
  securitySchemes:
    OAuth:
      type: http
      scheme: bearer
      description: OAuth 2.0 authentication

```

## Examples



**Request**

```json
{
  "grantee": {
    "memberId": "a1b2c3d4-e5f6-7890-abcd-ef1234567890"
  },
  "permission": "admin",
  "inodeId": "f47ac10b-58cc-4372-a567-0e02b2c3d479"
}
```

**Response**

```json
{
  "grantId": "9f8e7d6c-5b4a-3210-9fed-cba987654321",
  "inodeId": "f47ac10b-58cc-4372-a567-0e02b2c3d479",
  "organizationId": "org-1234567890abcdef",
  "memberId": "a1b2c3d4-e5f6-7890-abcd-ef1234567890",
  "teamId": "null",
  "permission": "admin",
  "createdBy": "admin-user-001",
  "updatedBy": "admin-user-001",
  "createdAt": "2024-01-15T09:30:00Z",
  "updatedAt": "2024-01-15T09:30:00Z",
  "inodeType": "folder"
}
```

**SDK Code**

```python
import requests

url = "https://api.sigmacomputing.com/v2/grants"

payload = {
    "grantee": { "memberId": "a1b2c3d4-e5f6-7890-abcd-ef1234567890" },
    "permission": "admin",
    "inodeId": "f47ac10b-58cc-4372-a567-0e02b2c3d479"
}
headers = {
    "Authorization": "<token>.",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.sigmacomputing.com/v2/grants';
const options = {
  method: 'POST',
  headers: {Authorization: '<token>.', 'Content-Type': 'application/json'},
  body: '{"grantee":{"memberId":"a1b2c3d4-e5f6-7890-abcd-ef1234567890"},"permission":"admin","inodeId":"f47ac10b-58cc-4372-a567-0e02b2c3d479"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/grants"

	payload := strings.NewReader("{\n  \"grantee\": {\n    \"memberId\": \"a1b2c3d4-e5f6-7890-abcd-ef1234567890\"\n  },\n  \"permission\": \"admin\",\n  \"inodeId\": \"f47ac10b-58cc-4372-a567-0e02b2c3d479\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<token>.")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/grants")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<token>.'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"grantee\": {\n    \"memberId\": \"a1b2c3d4-e5f6-7890-abcd-ef1234567890\"\n  },\n  \"permission\": \"admin\",\n  \"inodeId\": \"f47ac10b-58cc-4372-a567-0e02b2c3d479\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.sigmacomputing.com/v2/grants")
  .header("Authorization", "<token>.")
  .header("Content-Type", "application/json")
  .body("{\n  \"grantee\": {\n    \"memberId\": \"a1b2c3d4-e5f6-7890-abcd-ef1234567890\"\n  },\n  \"permission\": \"admin\",\n  \"inodeId\": \"f47ac10b-58cc-4372-a567-0e02b2c3d479\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.sigmacomputing.com/v2/grants', [
  'body' => '{
  "grantee": {
    "memberId": "a1b2c3d4-e5f6-7890-abcd-ef1234567890"
  },
  "permission": "admin",
  "inodeId": "f47ac10b-58cc-4372-a567-0e02b2c3d479"
}',
  'headers' => [
    'Authorization' => '<token>.',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/grants");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<token>.");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"grantee\": {\n    \"memberId\": \"a1b2c3d4-e5f6-7890-abcd-ef1234567890\"\n  },\n  \"permission\": \"admin\",\n  \"inodeId\": \"f47ac10b-58cc-4372-a567-0e02b2c3d479\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<token>.",
  "Content-Type": "application/json"
]
let parameters = [
  "grantee": ["memberId": "a1b2c3d4-e5f6-7890-abcd-ef1234567890"],
  "permission": "admin",
  "inodeId": "f47ac10b-58cc-4372-a567-0e02b2c3d479"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/grants")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```